import apiFormImport from "../api/apiForm";
let apiForm = apiFormImport.apis;
let axios = null;

export default {
    name: "FORM_RES_GLOBAL",

    OBJ_RES: {}, // 资源缓存
    AUTH_RES: {}, // 权限缓存
    PAGE_RES: {}, // 页面数据缓存

    install(Vue,opts){
        axios = opts.axios;
    },

    /**
     * 根据ID获取资源信息
     * @param id
     * @returns {*}
     */
    getById(id) {
        return new Promise(resolve => {
            if(!this.OBJ_RES[id]){
                axios.post(apiForm.plFormResource.getById, {id: id}).then(res => {
                    if(res.data){
                        this.OBJ_RES[id] = res.data|| {};
                        resolve(this.OBJ_RES[id]);
                    }
                });
            }else{
                resolve(this.OBJ_RES[id]);
            }
        });
    },

    analyseAuth(pageId) {
        return new Promise(resolve => {
            if(!this.AUTH_RES[pageId]){
                axios.post(apiForm.plAuthSetting.getAuthInfo, {pageId:pageId}).then(res => {
                    if(res.data){
                        this.AUTH_RES[pageId] = res.data|| {};
                        resolve(this.AUTH_RES[pageId]);
                    }
                });
            }else{
                resolve(this.AUTH_RES[pageId]);
            }
        });
    },

    findPageInf0 (key) {
        return new Promise(resolve => {
            if(!this.PAGE_RES[key]){
                axios.post(apiForm.plPageInfo.find, {defineKey: key,order:'create_time desc'}).then(res => {
                    if(res.data){
                        this.PAGE_RES[key] = res.data|| {};
                        resolve(this.PAGE_RES[key]);
                    }
                });
            }else{
                resolve(this.PAGE_RES[key]);
            }
        });
    }
}
